'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var React = require('react');
var utilsCommons = require('@highlight-ui/utils-commons');
var icon = require('@highlight-ui/icon');
var panel = require('@highlight-ui/panel');
var typography = require('@highlight-ui/typography');
function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};

// TODO: The values are going to be refactored to use tokens directly instead of SCSS exports
var mainPalette = function (p) {
  return p;
}([{
  identifier: 'support-red-100',
  backgroundColor: '#F55549',
  highlight: '#F55549'
}, {
  identifier: 'support-pink-100',
  backgroundColor: '#E8467C',
  highlight: '#E8467C'
}, {
  identifier: 'support-purple-100',
  backgroundColor: '#9F3EB0',
  highlight: '#9F3EB0'
}, {
  identifier: 'support-purple-80',
  backgroundColor: '#7D5CB8',
  highlight: '#7D5CB8'
}, {
  identifier: 'support-dark-blue-100',
  backgroundColor: '#0D34A2',
  highlight: '#0D34A2'
}, {
  identifier: 'cyan',
  backgroundColor: '#0db5df',
  highlight: '#0db5df'
}, {
  identifier: 'support-green-100',
  backgroundColor: '#3C968D',
  highlight: '#3C968D'
}, {
  identifier: 'support-light-green-100',
  backgroundColor: '#8BC34A',
  highlight: '#8BC34A'
}, {
  identifier: 'support-yellow-100',
  backgroundColor: '#F4E453',
  highlight: '#F4E453'
}, {
  identifier: 'orange',
  backgroundColor: '#ffa319',
  highlight: '#ffa319'
}, {
  identifier: 'support-brown-100',
  backgroundColor: '#795548',
  highlight: '#795548'
}, {
  identifier: 'support-grey-110',
  backgroundColor: '#5A7886',
  highlight: '#5A7886'
}]);
var pastelPalette = function (p) {
  return p;
}([{
  identifier: 'support-red-10',
  backgroundColor: '#F8CCC9',
  highlight: '#F55549'
}, {
  identifier: 'support-pink-10',
  backgroundColor: '#F5C3D4',
  highlight: '#E8467C'
}, {
  identifier: 'support-purple-10',
  backgroundColor: '#D5CAE9',
  highlight: '#9F3EB0'
}, {
  identifier: 'light-purple',
  backgroundColor: '#e1c5e7',
  highlight: '#7D5CB8'
}, {
  identifier: 'support-dark-blue-10',
  backgroundColor: '#CFD6EC',
  highlight: '#0D34A2'
}, {
  identifier: 'light-cyan',
  backgroundColor: '#bbe5f8',
  highlight: '#0db5df'
}, {
  identifier: 'support-green-10',
  backgroundColor: '#BBE1DD',
  highlight: '#3C968D'
}, {
  identifier: 'support-light-green-10',
  backgroundColor: '#DEECCE',
  highlight: '#8BC34A'
}, {
  identifier: 'support-yellow-10',
  backgroundColor: '#FBF6CA',
  highlight: '#F4E453'
}, {
  // TODO: Replace hardcoded color with a color token in DST-2558
  identifier: 'light-orange',
  backgroundColor: '#fbe1bb',
  highlight: '#ffa319'
}, {
  identifier: 'support-brown-10',
  backgroundColor: '#D9D0CD',
  highlight: '#795548'
}, {
  identifier: 'support-grey-10',
  backgroundColor: '#D3DADE',
  highlight: '#5A7886'
}]);
var styles = {
  "colorOption": "ColorPicker-module__FYnj0znF__v4-3-7",
  "button": "ColorPicker-module__SOXvFt0b__v4-3-7",
  "colorPicker": "ColorPicker-module__iT9dyWOR__v4-3-7",
  "focus": "ColorPicker-module__9aA16Fvg__v4-3-7",
  "active": "ColorPicker-module__nntKqhC3__v4-3-7",
  "disabled": "ColorPicker-module__SSj3wtEw__v4-3-7",
  "buttonArrow": "ColorPicker-module__s0S9P-x5__v4-3-7",
  "colorDot": "ColorPicker-module__tAkCpZCm__v4-3-7",
  "panel": "ColorPicker-module__j47-5ppo__v4-3-7",
  "colorOptions": "ColorPicker-module__bPum-aBR__v4-3-7"
};
var ColorPicker = function (_a) {
  var _b = _a.closeOnSelect,
    closeOnSelect = _b === void 0 ? false : _b,
    disabled = _a.disabled,
    initialColor = _a.initialColor,
    metadata = _a.metadata,
    onChange = _a.onChange,
    _c = _a.palette,
    palette = _c === void 0 ? 'main' : _c,
    title = _a.title;
  var _d = React.useState(false),
    focused = _d[0],
    setFocused = _d[1];
  var wrapperRef = React.useRef(null);
  var colorPalette = palette === 'pastel' ? pastelPalette : mainPalette;
  var _e = React.useState(false),
    isPaletteOpen = _e[0],
    setIsPaletteOpen = _e[1];
  var _f = React.useState(initialColor === undefined ? colorPalette[0].backgroundColor : initialColor),
    currentColor = _f[0],
    setCurrentColor = _f[1];
  React.useEffect(function () {
    var onDocumentClick = function (e) {
      if (wrapperRef.current && e.target instanceof Node && !wrapperRef.current.contains(e.target)) {
        setIsPaletteOpen(false);
      }
    };
    window.document.addEventListener('mousedown', onDocumentClick);
    return function () {
      window.document.removeEventListener('mousedown', onDocumentClick);
    };
  }, []);
  var getComputedColor = function (cssColorVariable) {
    // Replace var(--support-red-100) with --support-red-100
    var cssVar = cssColorVariable.replace(/(^.*\(|\).*$)/g, '');
    return getComputedStyle(document.documentElement).getPropertyValue(cssVar).trim();
  };
  var onColorClick = function (selectedColor) {
    // TODO: Remove isHexColor check in DST-2558
    var isHexColor = selectedColor.startsWith('#');
    var color = isHexColor ? selectedColor : getComputedColor(selectedColor);
    onChange(color);
    setCurrentColor(selectedColor);
    if (closeOnSelect) {
      setIsPaletteOpen(false);
    }
  };
  return React__default["default"].createElement("div", {
    className: styles.colorPicker,
    ref: wrapperRef
  }, React__default["default"].createElement("button", __assign({}, utilsCommons.parseMetadata(metadata), {
    className: styles.button,
    disabled: disabled,
    onClick: function () {
      return setIsPaletteOpen(!isPaletteOpen);
    },
    onFocus: function () {
      return setFocused(true);
    },
    onBlur: function () {
      return setFocused(false);
    },
    type: "button"
  }), React__default["default"].createElement("div", {
    className: styles.colorDot,
    "data-test-id": "selected-color",
    style: {
      background: currentColor
    }
  }), React__default["default"].createElement(icon.Icon, {
    className: styles.buttonArrow,
    name: "sort-down",
    type: "solid",
    color: focused ? 'icon-highlight' : 'icon-subdued'
  })), isPaletteOpen && React__default["default"].createElement(panel.Panel, {
    className: styles.panel,
    absolute: true
  }, React__default["default"].createElement(typography.Heading, {
    variant: "small",
    as: "span",
    color: "text-default"
  }, title), React__default["default"].createElement("div", {
    className: styles.colorOptions
  }, colorPalette.map(function (_a) {
    var identifier = _a.identifier,
      backgroundColor = _a.backgroundColor,
      highlight = _a.highlight;
    return React__default["default"].createElement("div", {
      className: styles.colorOption,
      "aria-label": "select-color-".concat(identifier),
      key: identifier,
      onClick: function () {
        return onColorClick(backgroundColor);
      },
      onKeyDown: function (e) {
        return e.key === 'Enter' && onColorClick(backgroundColor);
      },
      role: "button",
      style: {
        backgroundColor: backgroundColor,
        color: highlight
      },
      tabIndex: 0
    });
  }))));
};
exports.ColorPicker = ColorPicker;
//# sourceMappingURL=index.js.map
